package jwars.data;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public abstract class MoveableCategory extends UnitCategory {

  public final double speed;
  public final double turnRate;
  public final List<WeaponCategory> weaponry;

  public MoveableCategory(Loader loader, Scanner input){
    super(loader, input);
    this.speed = loader.readNumber(input);
    this.turnRate = loader.readNumber(input);
    String next = input.next();
    if(!next.equals(Syntax.BLOCK_START)){
      throw new IllegalArgumentException("Bad syntax! Expected: "+Syntax.BLOCK_START+". Found: "+next);
    }
    ArrayList<WeaponCategory> weaponry = new ArrayList<WeaponCategory>();
    while( !(next=input.next()).equals(Syntax.TERMINATOR)){
      WeaponCategory w = loader.getWeapon(next);
      weaponry.add(w);
    }
    weaponry.trimToSize();
    this.weaponry = Collections.unmodifiableList(weaponry);
  }

  public String toString(){
    return name;
  }

}
