package jwars.data;

import java.util.Scanner;

import jwars.event.EventQueue;
import jwars.model.WarModel;
import jwars.model.weapons.Weapon;

public class WeaponCategory extends Category<Weapon> {

  public final static String CATEGORY_NAME = "weapon";
  public final String name;
  public final double range;
  public final double effectiveRange;
  public final double reloadTime;

  private final EventQueue reloadQueue;

  public WeaponCategory(Loader loader, Scanner input){
    super(input);
    name = input.findWithinHorizon(Syntax.QUOTE_PATTERN, 0).replaceAll(Syntax.QUOTE, "");
    range = loader.readNumber(input);
    effectiveRange = loader.readNumber(input);
    reloadTime = loader.readNumber(input);
    reloadQueue = new EventQueue(WarModel.WORLD.secondsToFrames(reloadTime));
    WarModel.QUEUES.register(reloadQueue);
  }

  public String toString(){
    return name;
  }

  public Weapon create(){
    return new Weapon(this, reloadQueue);
  }

}
