package jwars.event;



/**
 * An Event which allows the user to manually specify the time at which this
 * event should be executed. This is useful when instructions are received
 * from a network, which should be executed at some other time than the
 * EventQueue would allow.
 */
public abstract class TimedEvent extends Event{

  public TimedEvent(EventQueue eq){
    super(eq);
  }

  /**
   * Enqueues this and sets the execution time equal to the argument.
   * @param time int
   */
  public void enqueue(int time){
    super.enqueue();
    this.time = time;
    //if(time < jwars.Util.TIMER.getTime()){
    //  System.out.println("<TimedEvent> Error enqueueing TimedEvent!");
    //  throw new RuntimeException("<TimedEvent> Specified time stamp out of date!");
    //}
  }

}
