package jwars.gui.units;

import java.awt.Graphics2D;
import java.awt.Image;

public class ImageSprite extends Sprite {

  private Image image;
  private int imageWidth;
  private int imageHeight;
  private double theta;

  public ImageSprite(Image image){
    super(getImageRadius(image));
    this.image = image;
    this.imageWidth = image.getWidth(null);
    this.imageHeight = image.getHeight(null);
  }

  public void setTheta(double theta){
    this.theta = theta;
  }

  public void draw(Graphics2D g2d, int x, int y){
    g2d.rotate(theta,x,y);
    g2d.drawImage(image, x-imageWidth/2, y-imageHeight/2, null);
  }

  public static int getImageRadius(Image image){
    return (int)Math.ceil(Math.hypot(image.getWidth(null),
                                     image.getHeight(null))/2);
  }

}
