package jwars.model;

import jwars.model.map.CollisionTile;

public class CollisionProperties{

  CollisionTile generalLocation;
  int height = 0;
  boolean mobile;
  boolean massive;
  boolean ghost = false;
  //Two units that are both
  //Ghosts do not collide with anything

  public CollisionProperties(boolean massive, boolean mobile){
    this.massive = massive;
    this.mobile = mobile;
  }

  public boolean mayCollide(CollisionProperties other){
    //If at least one Collider is a ghost, no collision
    //---or---
    //neither Collider is massive
    return !(ghost || other.ghost || !(massive || other.massive));
  }

  public void setMassive(boolean massive){
    this.massive = massive;
  }

  /*public void setMobile(boolean mobile){
    this.mobile = mobile;
  }*/

}
