package jwars.model.ai.impl;

import jwars.model.Moveable;
import jwars.model.ai.AttackAI;
import jwars.model.ai.Attackable;

public class BasicAttacker implements AttackAI {

  private boolean isFiring = false;
  private Moveable owner;
  private Attackable target;
  private int targetX, targetY;

  public BasicAttacker(Moveable owner){
    this.owner = owner;
  }

  public void orderAttack(Attackable target){
    isFiring = true;
    this.target = target;
  }

  public void orderAttack(int x, int y, int radius){
    isFiring = true;
    target = null;
    this.targetX = x;
    this.targetY = y;
  }

  public double getTargetAngle(){
    if(!isFiring){
      return owner.getTheta();
    }
    int x, y;
    if(target != null){
      //Targetted fire
      x = target.getX();
      y = target.getY();
    } else {
      //Area fire
      x = targetX;
      y = targetY;
    }
    return Math.atan2(y - owner.getY(), x - owner.getX());
  }

  /*public void reportReloaded(){
    if(isFiring){

    }
  }*/

  public void orderHoldFire(){
    isFiring = false;
    target = null;
  }

  public boolean isFiring(){
    return isFiring;
  }

  public int getTargetX(){
    return target == null ? targetX : target.getX();
  }

  public int getTargetY(){
    return target == null ? targetY : target.getY();
  }

}
