package jwars.model.map;

import java.awt.Graphics;
import java.awt.Image;

public class TerrainTile{

  private /*Buffered*/Image ground;
  private Image vegetation;
  public final int xPix, yPix;
  private final int width;
  private final int height;
  private boolean isDirty = true;

  private final static boolean drawDebugGrid = false;

  public final int forestation;

  public TerrainTile(/*Buffered*/Image ground, Image vegetation, int xPix, int yPix, int forestation){
    this.vegetation = vegetation;
    this.forestation = forestation;
    this.ground = ground;
    this.width = ground.getWidth(null);
    this.height = ground.getHeight(null);
    this.xPix = xPix;
    this.yPix = yPix;
  }

  public void draw(Graphics g, int x, int y){
    g.drawImage(ground, x, y, null);
  }

  public void drawVegetation(Graphics g, int x, int y){
    if(forestation > 0){
      g.drawImage(vegetation, x, y, null);
      //g.setColor(Color.black);
      //g.drawString(""+forestation, x+10,y+10);
    }
    if(drawDebugGrid){
      g.drawRect(x, y, ground.getWidth(null), ground.getHeight(null));
    }
  }

  public void setDirty(boolean isDirty){
    this.isDirty = isDirty;
  }

  public boolean isDirty(){
    return isDirty;
  }

  /**
   * Vegetation-relevant stuff
   */
  /*public final static int MAX_FORESTATION = 4;
  private static int[] xValues = new int[MAX_FORESTATION];
  private static int[] yValues = new int[MAX_FORESTATION];
  private static int[] radii = new int[MAX_FORESTATION];
  static {
    Random rand = new Random(1);
    for(int i = 0; i < MAX_FORESTATION; i++){
      xValues = rand.nextInt()
    }
  }

  public static void draw(Graphics g, int x, int y, int w, int h, int forestation){
    g.setColor(Color.green);
    for(int i = 0; i<forestation; i++){
      drawTree(g, x + xValues[i], y+yValues[i], radii[i]);
    }
  }

  private static void drawTree(Graphics g, int x, int y, int radius){
    g.drawOval(x-radius,y-radius,2*radius, 2*radius);
  }*/

}
