package jwars.model.structures;

/**
 * <p>q w</p>
 *
 * <p>q w</p>
 *
 * <p>e r</p>
 *
 * <p>r t</p> y u i o
 */
import jwars.model.Coord;

public class PathFindingNode extends Coord implements Comparable<PathFindingNode>{

  //Pathfinding variables
  private int g, h;
  public int f;
  public PathFindingNode ancestor;
  public PathFindingNode baby;

  private int status;

  private double indentDirectionX, indentDirectionY;
  private Coord indentedLocation = new Coord(this);

  public PathFindingNode(){
    super();
    status = f = g = h = 0;
  }

  public PathFindingNode(Coord c){
    super(c);
    status = f = g = h = 0;
  }

  public void reset(){
    f = g = h = 0;
  }

  public void update(PathFindingNode from){
    int temp = from.f + this.dist(from);//distance(from, this);
    if(temp < this.h){
      this.h = temp;
      this.ancestor = from;
    }
  }

  public int compareTo(PathFindingNode other){
    return other.f - this.f;
  }

  /*public int compare(PathFindingNode c1, PathFindingNode c2){
    return c1.f-c2.f;
  }*/

  /*private static int distance(PathFindingNode first, PathFindingNode second){
    return (int)(Math.sqrt(sqr(second.x-first.x)+sqr(second.y-first.y)));
  }*/

  public Coord calculateDestinationFromCorner(int radius){
    int x = (int)(radius * indentDirectionX);
    int y = (int)(radius * indentDirectionY);
    this.indentedLocation.set(x,y);
    return this.indentedLocation;
  }

  public void setIndentDirection(double x, double y){
    this.indentDirectionX = x;
    this.indentDirectionY = y;
  }

  private static double sqr(int x){
    return x*x;
  }
}
