package jwars.model.units;

import java.awt.Graphics2D;

import jwars.Util;
import jwars.data.TankCategory;
import jwars.gui.units.ImageSprite;
import jwars.model.Moveable;

public class Tank extends Moveable{

  //public final static BufferedImage hull = Util.readImage("t34hull.png");
  //public final static BufferedImage turret = Util.readImage("t34turret.png");

  private TankSprite sprite;
  //private static int radius = WarModel.PIXEL_COORDS.transformToCoords(
  //    WarModel.WORLD.MAIN_COORDS, ImageSprite.getImageRadius(hull));

  private double turretAngle;
  //private static String tankName = "Tank";

  public final TankCategory CAT;

  public Tank(TankCategory cat){
    super(cat, true);
    CAT = cat;
    setSprite(new TankSprite());
    this.sprite = (TankSprite)getSprite();
    //this.theta = 2;
    this.sprite.setTheta(this.theta);
  }

  public void move(){
    super.move();
    sprite.setTheta(theta);
    //turretAngle += 0.05;
  }

  public boolean aimTowards(double theta){
    double angleDiff = Util.minusPiToPi(theta - this.theta - this.turretAngle);
    dirtify();

    //double turretAngle = Util.minusPiToPi(this.theta + this.turretAngle); //adjust for hull rotation
    //System.out.println("aim towards "+theta);
    double maxRotation = CAT.turret.traverseSpeed * dt;
    //System.out.println("max rotation deg "+(maxRotation*360/2/Math.PI));
    //double angleDiff = Util.minusPiToPi(theta - turretAngle);
    /*if(angleDiff != 0){
      dirtify();
    }*/
    if(maxRotation > Math.abs(angleDiff)){
      //System.out.println("rotating complete ");
      this.turretAngle = theta - this.theta;
      return true;
    } else {
      //System.out.println("rotating...");
      this.turretAngle += maxRotation * Math.signum(angleDiff);
      return false;
    }
  }

  private class TankSprite extends ImageSprite{

    public TankSprite(){
      super(CAT.hull.graphics);
      super.setRadius(Math.max(getImageRadius(CAT.hull.graphics), getImageRadius(CAT.turret.graphics)));
    }

    public void draw(Graphics2D g, int x, int y){
      //System.out.println("drawing tank");
      super.draw(g, x, y);
      //g.translate(x-turret.getWidth()/2, y-turret.getHeight()/2);
      g.rotate(turretAngle, x, y);
      g.drawImage(CAT.turret.graphics, x-CAT.turret.graphics.getWidth()/2, y-CAT.turret.graphics.getHeight()/2, null);
    }

  }

}
