package jwars.model.units;

import java.awt.Color;
import java.awt.image.BufferedImage;
import javax.swing.ImageIcon;

import jwars.model.Formation;

public class Team
    extends Formation{

  private Team opponent;
  private int score=42; //not used yet, but this is what this class is (in part) about

  public final String NAME;
  public final String NAME_SHORT;
  public final String NAME_NOUN;
  public final String NAME_ADJECTIVE;
  public final Color TEAM_COLOR;
  public final ImageIcon FLAG;

  public Team(String name, String shortName, String noun, String adjective, BufferedImage flag, Color color){
    super(name, Integer.MAX_VALUE);
    this.NAME = name;
    this.FLAG = new ImageIcon(flag);
    this.NAME_SHORT = shortName;
    this.NAME_NOUN = noun;
    this.NAME_ADJECTIVE = adjective;
    this.TEAM_COLOR = color;
  }

  public void setOpponent(Team opponent){
    this.opponent = opponent;
  }

  public boolean enemyOf(Team other){
    return this != other; //Presently all teams are opponents
  }

  public Team opponent(){
    return opponent; //Presently only one opponent
  }

  public int getScore(){
    return score;
  }

  public boolean isSelectable(){
    return false;
  }

}
