package jwars.model.weapons;

import jwars.data.WeaponCategory;
import jwars.event.Event;
import jwars.event.EventQueue;
import jwars.model.WarModel;
import jwars.test.explosions.Explosion;


public class Weapon{

  //private EventQueue reloadQueue;
  private ReloadEvent reloadEvent;
  //private Shell shell;
  private boolean isLoaded = true;
  private final WeaponCategory CAT;
  private ReloadListener listener;
  private Shell shell = new Shell();

  public Weapon(WeaponCategory category, EventQueue queue){
    this.CAT = category;
    reloadEvent = new ReloadEvent(queue);
  }

  /*public Weapon(Shell shell, int reloadTime){
    //this.shell = shell;
    //reloadQueue = new EventQueue(reloadTime);
    //reloadEvent = new ReloadEvent();
    //Possible other params: accuracy, range, stabilization, etc.
    //May also be influenced by unit experience etc.
  }*/

  public Shell fire(int srcX, int srcY, int dstX, int dstY){
    if(!isLoaded){
      throw new RuntimeException("Cannot fire weapon which is not loaded!");
    }
    float dx = dstX - srcX;
    float dy = dstY - srcY;
    float distSqr = dx*dx + dy*dy;
    if(distSqr > CAT.range * CAT.range){
      return null;
    }
    isLoaded = false;
    reloadEvent.enqueue();

    WarModel.WORLD.addDynamicSprite(new Explosion(dstX, dstY));
    return shell;
  }

  public boolean isLoaded(){
    return isLoaded;
  }

  void setReloadListener(ReloadListener listener){
    this.listener = listener;
  }

  private class ReloadEvent extends Event {

    public ReloadEvent(EventQueue queue){
      super(queue);
    }

    protected void execute(){
      isLoaded = true;
      boolean fireAgain = listener.reportReloaded(Weapon.this);
      //jwars.Util.out.println("click!");
      //if(fireAgain){
      //  fire();
      //}
    }

  }

}
