package jwars.synch;



/**
 * The Watch interface is implemented to tell the Timer class that objects
 * of this this class are able to return the current time in relation to some
 * arbitrary reference time.
 *
 * For example, a Watch could be used to delegate the System.currentTimeMillis()
 * or System.nanoTime() methods, or use 3rd party libraries.
 */
public interface Watch{

    /**
     * Returns the total time in milliseconds
     * elapsed since some arbitrary reference point.
     * @return current time in milliseconds
     */
    public long currentTimeMillis();

}
