package jwars.test.explosions;

import java.awt.Graphics2D;
import java.awt.Image;

import jwars.Util;
import jwars.model.DynamicSprite;

public class Explosion extends DynamicSprite {

  private int x, y;
  int startTime;

  public Explosion(int x, int y){
    this.x = x;
    this.y = y;
    this.startTime = Util.TIMER.getTime();
  }

  public boolean draw(Graphics2D g, int x, int y, int time){
    Image im = Explosions.getImage((time-startTime)/2);
    if(im != null){
      g.drawImage(im, x-im.getWidth(null)/2, y-im.getHeight(null)/2, null);
      return true;
    } else {
      return false;
    }
  }

  public int getX(){
    return x;
  }

  public int getY(){
    return y;
  }

}
