package jwars.test.explosions;

import java.util.List;

import java.awt.Image;

public final class Explosions{

  private final static List<Image> standard;
  public final static int length;

  static {
    int minSize = 8;
    int maxSize = 20;
    int minTime = 5;
    int maxTime = 10;

    int spread = 8;
    int sparksPerFrame = 16;
    int duration = 5;
    long seed = 0;

    ExplosionGenerator gen = new ExplosionGenerator(minSize, maxSize, minTime, maxTime);
    standard = gen.createRoundExplosion(spread, sparksPerFrame, duration, seed);
    length = standard.size();
  }

  public static void init(){
    //Now the static things have been initialized, in case it is better to initialize now than at an unknown later time
  }

  public static Image getImage(int time){
    if(time >= length){
      return null;
    } else {
      return standard.get(time);
    }
  }

}
